/*******************************************************************************
 * Copyright 2011 @ Kapil Viren Ahuja
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package com.kapil.framework.database;

// TODO: Auto-generated Javadoc
/**
 * <p>
 * Interface to setting up database. This Interface is intended to be used by implementations
 * that setup database during testing scenarios so that different test suits and 
 * methods can use those database during execution.
 * </p>
 *
 * <p>
 * This interface will externalize the db interaction to use of query files, thus eliminating
 * the need of developers writing inline sql statements.
 * </p>
 */
public interface IDatabaseSetup
{
    
    /**
     * Setup database.
     */
    void setupDatabase();
}
